package com.nisum.offertransactionservice.controller;

import com.nisum.offertransactionservice.dto.Item;
import com.nisum.offertransactionservice.dto.OfferTransactionRequest;
import io.restassured.RestAssured;
import org.hamcrest.Matchers;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.ArrayList;
import java.util.List;

import static io.restassured.RestAssured.with;

@SpringBootTest
public class OfferTransactionControllerIntegrationTest {

    @BeforeEach
    public void setup() {
        RestAssured.baseURI = "http://localhost";
        RestAssured.port = 7072;
    }


    @Test
    public void getOfferTransactionResponseTest() {
        with().body(getOfferTransactionRequest())
                .when()
                .request("POST", "/offerTransactionCall")
                .then()
                .statusCode(200)
                .body("offerTransactionCall.offerTransactionResponse.transactionId", Matchers.notNullValue());
    }

    private OfferTransactionRequest getOfferTransactionRequest() {
        OfferTransactionRequest offerTransactionRequest = new OfferTransactionRequest();
        offerTransactionRequest.setHhId(54321L);
        offerTransactionRequest.setItemList(getItemList());
        return offerTransactionRequest;
    }

    private List<Item> getItemList() {
        List<Item> itemList = new ArrayList<>();
        Item item1 = new Item("Coke", "12", 13.05);
        Item item2 = new Item("Thumpsup", "11", 14.05);
        itemList.add(item1);
        itemList.add(item2);
        return itemList;
    }
}
